////////////////////////////////////////////////////////////////////////////////
//
// Test programmer's method on one file.
//
////////////////////////////////////////////////////////////////////////////////


package clone;


import java.io.*;
import java.util.*;

import edu.cmu.cs.pattis.cs151xx.*;

import introExam.BinarySearchTree.*;



public class Test {


  public static void testOne (String name)
  {
    try {
      System.out.println ("Testing: " + name.substring(Menu.inputDirectory.length() + Menu.sepLen));
      TypedBufferReader tbr = new TypedBufferReader("\""+name);
       
      //Read and print comment line
      String line = tbr.readLine();
      System.out.println ("Comment: " +line);
      System.out.println ("Trees are rotated 90 degress counter-clockwise"); 
      System.out.println ();

      //Read input and build structure
      ExtendedBST original = new ExtendedBST();
      while (true) {
        String value = tbr.readLine(); 
        if (value.equals("*"))
          break;
        original.insert (value);
      }

      //Read correct output
      List correct = new ArrayList();
      while (true) {
        String value = tbr.readLine(); 
        if (value.equals("*"))
          break;
        correct.add(value);
      }

      //Print input (as tree)
      System.out.println ("Original Tree:");
      System.out.println (); 
      System.out.println (original);
      System.out.println (); 

      //UPDATE METHOD CALL
      ExtendedBST clone = original.cloneTree();
      original.insert ("If-you-see-this-your-code-is-incorrect");

      //Print user answer
      System.out.println ("Student Output:");
      System.out.println (); 
      System.out.println (clone);
      System.out.println (); 
      
      //If no output files, print answer here
      if ( !(new File("output")).isDirectory() ) {
        System.out.println ("Correct Output:");
        System.out.println (); 
        for (int i=0; i<correct.size(); i++)
          System.out.println(correct.get(i));
        System.out.println (); 
        System.out.println (); 
      }

      System.out.println (); 
   }
   catch (Exception e) {   
     e.printStackTrace();
   }
  }


  public static void main (String[] args)
  {
    for(;;)
      //UPDATE METHOD NAME
      for (StringTokenizer st = new StringTokenizer(Menu.getFiles("Test Menu For 'CloneBST'")); st.hasMoreTokens(); )
        testOne(st.nextToken());
  }

}
